//+-------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                               e-FractalPredictor_FXGeneral.mq4 |
//|                                                                                                                                       FXGeneral |
//|                                                                                                                            http://fxgeneral.com |
//+-------------------------------------------------------------------------------------------------------------------------------------------------+
#property copyright  " FXGeneral, 2010"
#property link       "     http://fxgeneral.com"
#property copyright  "Coded by Necron | mailto: mqlcoder@yandex.ru"

#define SEC 1000  

extern int        MagicNumber    =  123456789   ;        //  ,    ,   ; 
extern int        StopLoss       =  100         ;        //  ;
extern int        TakeProfit     =  200         ;        //   (-1  0   );
extern int     LotsPercent            =  1         ;        //  ;
//extern double lot=0.1;
extern string     P1             =  "======================";
extern bool       UseFilter      =  false;   

extern double     x0             =  10          ; 
extern double     x1             =  10          ; 
extern double     x2             =  10          ; 
extern double     x3             =  10          ; 
//extern double     x4             =  10          ; 
//extern double     x5             =  10          ; 
//extern double     x6             =  10          ; 

int NumOfTries=3;              
int LastSignal;
//-------------------------------------------------------------------------------------------------------------------------------------------------//
int init()  
{
   CreateLabel("copyright1","    ",Gray,10,30,3,10);    
   CreateLabel("copyright2","fxgeneral.com",Red,50,10,3,10);  

 return(0);
}
//-------------------------------------------------------------------------------------------------------------------------------------------------//
int deinit()   
{
if(ObjectFind("copyright1")!=-1) ObjectDelete("copyright1"); 
   if(ObjectFind("copyright2")!=-1) ObjectDelete("copyright2");
 return(0);
}
//-------------------------------------------------------------------------------------------------------------------------------------------------//
int start() 
{
   static datetime bartime;
   datetime tm=Time[0];
   
   if(bartime==tm)return(0);
   bartime=tm;
   
   double Orders[10][10];
   string Symbol_=Symbol();
   OrdersManagement_Mono(Orders,Symbol_,MagicNumber);
   int TotalBuy=0;
   int TotalSell=0;
   vOrderCalculate(Orders,TotalBuy,TotalSell);
   
   double Point_=PointX();
   int signal=Signal();
   datetime TimeCurrent_=TimeCurrent();
   int Period_=Period();
   int sleep_time=Period_*60*3;
   double lot=MathCeil(AccountBalance()/10000*LotsPercent)/10;
   if(TotalBuy<1 && LastSignal!=1 && signal==1 && TimeCurrent_>=(sleep_time+LastOpenTime(Orders,OP_BUY)))  {
   //   OrdersClose(Orders,OP_SELL);
      OrderSend_(Symbol_,OP_BUY,lot,Ask,3,Bid-StopLoss*Point_,Ask+TakeProfit*Point_,"FractalPredictor",MagicNumber,0,Lime); 
   }      
   if(TotalSell<1 && LastSignal!=-1 && signal==-1 && TimeCurrent_>=(sleep_time+LastOpenTime(Orders,OP_SELL))) {
   //   OrdersClose(Orders,OP_BUY);
      OrderSend_(Symbol_,OP_SELL,lot,Bid,3,Ask+StopLoss*Point_,Bid-TakeProfit*Point_,"FractalPredictor",MagicNumber,0,Red); 
   }
   LastSignal=signal;
 return(0);
}
//-------------------------------------------------------------------------------------------------------------------------------------------------//
double PointX(string sy="0")   {
   if(sy=="0")sy=Symbol(); 
   int      dg=MarketInfo(sy,MODE_DIGITS);
   double   _return=0.0,
            po=MarketInfo(sy,MODE_POINT);
   if(dg==5||dg==3) _return=po*10;
   else  _return=po;
 return(_return);
}
void CreateLabel(string name, string txt, color clr, int x, int y,int corner,int FontSize)  {
  if (ObjectFind(name)<0) ObjectCreate(name, OBJ_LABEL, 0, 0,0);
  ObjectSetText(name, txt, FontSize);
  ObjectSet(name, OBJPROP_COLOR    , clr);
  ObjectSet(name, OBJPROP_XDISTANCE, x);
  ObjectSet(name, OBJPROP_YDISTANCE, y);
  ObjectSet(name, OBJPROP_CORNER   , corner);
  ObjectSet(name, OBJPROP_FONTSIZE , FontSize);
}
void vOrderCalculate(double order[][],int &buys,int &sells)   
{
   buys=0;
   sells=0;
   
   for(int i=1;i<=order[0][0];i++)  {
      int TY=order[i][2];
      if(TY==OP_BUY) buys++;
      if(TY==OP_SELL)sells++;
   }
}

double Perceptron(datetime t_start=0)
{
   string Symbol_=Symbol();
   int Period_=Period();
   int shift=iBarShift(Symbol_,Period_,t_start,true);
   if(shift==-1)  {
      Print("  : "+TimeToStr(t_start,TIME_DATE|TIME_MINUTES));
      return(0);
   }  
   double bar[7];
   int cnt=0;
   double HL,LO,LC; // http://forum.mql4.com/ru/33268
   for(int i=shift;i<=shift+3;i++)  {
      
      double h=iHigh(Symbol_,Period_,i);
      double l=iLow(Symbol_,Period_,i);
      double o=iOpen(Symbol_,Period_,i);
      double c=iClose(Symbol_,Period_,i);
      
      HL=h-l;
      if(HL==0)HL=PointX();
      LO=o-l;
      LC=c-l;
      bar[cnt]=0.5*(LO/HL+LC/HL);      
      cnt++;           
   }
   
   double w0=x0-100.0;
   double w1=x1-100.0;
   double w2=x2-100.0;
   double w3=x3-100.0;
//   double w4=x4-100.0;
//   double w5=x5-100.0;
//  double w6=x6-100.0;
   
   return(w0*bar[0] + w1*bar[1] + w2*bar[2] + w3*bar[3] /*+ w4*bar[4] + w5*bar[5] + w6*bar[6]*/);     
}
int Signal()
{
   double up=0.0;
   double dn=0.0;
   IsFractal(up,dn,1,3); 
   datetime Time_=Time[1];
   if(up!=0) {
      if(!UseFilter || (UseFilter && Perceptron(Time_)<0))  {
         return(-1);
      }
   }
   if(dn!=0)   {
      if(!UseFilter || (UseFilter && Perceptron(Time_)>0))  {
         return(1);
      }
   }
 return(0); 
}
void IsFractal(double &up,double &dn,int shift, int bars_from_side)
{
   string   Symbol_=Symbol();
   int      Period_=Period();
   up=0; dn=0;
   bool h_found=true;
   bool l_found=true;
   int i;
   //---   
   for(i=shift;i<=shift+bars_from_side;i++)  {
      if(iHigh(Symbol_,Period_,i)>iHigh(Symbol_,Period_,shift))  {
         h_found=false;
         break;
      }   
   }
   if(h_found) up=iHigh(Symbol_,Period_,shift);  
   
   //---   
   for(i=shift;i<=shift+bars_from_side;i++)  {
      if(iLow(Symbol_,Period_,i)<iLow(Symbol_,Period_,shift))  {
         l_found=false;
         break;
      }   
   }
   if(l_found) dn=iLow(Symbol_,Period_,shift);  
 return;
}
int OrderSend_(string sy,int cmd,double volume,double pr,int slip,double sl,double tp,string comment="",int magic=0,datetime expiration=0,color clr=Gray)
{
   int ticket=-1;
   double StopLevel=0.0;
   double Point_=PointX(sy);
   int Digits_=MarketInfo(sy,MODE_DIGITS);
   
   for(int i=1;i<=NumOfTries;i++)   {
      while (!IsTradeAllowed()) Sleep(5*SEC);
      
      double Bid_=MarketInfo(sy,MODE_BID);
         double Ask_=MarketInfo(sy,MODE_ASK);
         
         StopLevel=MarketInfo(sy,MODE_STOPLEVEL);
         if(Digits_==3 || Digits_==5) StopLevel/=10;
         
         if(sl!=0)   {
            double new_sl=0.0;
            if(cmd==OP_BUY)   {
               if(Bid_-sl<StopLevel*Point_)  {
                  new_sl=Bid_-(StopLevel+1)*Point_;
                  Print("OrderSend_:  \"sl\"    ! "+DoubleToStr(sl,Digits_)+"->"+DoubleToStr(new_sl,Digits_)+"");
                  sl=new_sl;
               }
            }
            if(cmd==OP_SELL)  {
               if(sl-Ask_<StopLevel*Point_)  {
                  new_sl=Ask_+(StopLevel+1)*Point_;
                  Print("OrderSend_:  \"sl\"    ! "+DoubleToStr(sl,Digits_)+"->"+DoubleToStr(new_sl,Digits_)+"");
                  sl=new_sl;
               }
            }
         }
         if(tp!=0)   {
            double new_tp=0.0;
            if(cmd==OP_BUY)   {
               if(tp-Ask_<StopLevel*Point_)  {
                  new_tp=Ask_+(StopLevel+1)*Point_;
                  Print("OrderSend_:  \"tp\"    ! "+DoubleToStr(tp,Digits_)+"->"+DoubleToStr(new_tp,Digits_)+"");
                  tp=new_tp;
               }
            }
            if(cmd==OP_SELL)  {
               if(Bid_-tp<StopLevel*Point_)  {
                  new_tp=Bid_-(StopLevel+1)*Point_;
                  Print("OrderSend_:  \"tp\"    ! "+DoubleToStr(tp,Digits_)+"->"+DoubleToStr(new_tp,Digits_)+"");
                  tp=new_tp;
               }
            }
         }     
      if(cmd==OP_BUY)   pr=Ask_;
      if(cmd==OP_SELL)  pr=Bid_;
      
      pr=nd(pr,sy);
      sl=nd(sl,sy);
      tp=nd(tp,sy);
      volume=NormalizeLot(volume,sy);
      if(AccountFreeMarginCheck(sy,cmd,volume)<=0) {
         Print("       "+sy+"  "+DoubleToStr(volume,2)+"!");
         break;
      }
      ticket=OrderSend(sy,cmd,volume,pr,slip,sl,tp,comment,magic,expiration,clr);  
      if(ticket>0) break;
      else {
         Sleep(5*SEC);
         continue;
      }  
   }
   return(ticket);   
} 
bool OrderClose_(int ticket,double lots,double price,int slippage,color clr)
{
   if(OrderSelect(ticket,SELECT_BY_TICKET))  {
      if(OrderCloseTime()>0)  {
         Print("OrderClose_:    #"+ticket+"  .");
         return(false);
      }
   }    
   double OOP=OrderOpenPrice();
   double OSL=OrderStopLoss();
   double OTP=OrderTakeProfit();
   string OSY=OrderSymbol();
   int OTY=OrderType();
   
   bool isClosed=false;
   for(int i=1;i<=NumOfTries;i++)   {
      while (!IsTradeAllowed()) Sleep(5*SEC);
      
      double Bid_=MarketInfo(OSY,MODE_BID);
      double Ask_=MarketInfo(OSY,MODE_ASK);
         
      if(OTY==OP_BUY)   price=Bid_;
      if(OTY==OP_SELL)  price=Ask_;
      
      price=nd(price,OSY);
      lots=NormalizeLot(lots,OSY);
      isClosed=OrderClose(ticket,lots,price,slippage,clr);
      if(isClosed) return(true);
      else  {
         Sleep(3*SEC);
         continue;
      }  
   }
   return(false); 
}
void OrdersModify(double order[][],double new_sl,double new_tp,int ty) 
{
   double dOP=0.0;
   int iTy=-1;
   int iTi=-1;
   for(int i=1;i<=order[0][0];i++)  {
      iTy=order[i][2];
      if(iTy==ty) {
        
         iTi=order[i][1];
         dOP=order[i][4];
//          Print("  "+iTi);
         if(new_tp==-1) new_tp=order[i][6];
         OrderModify_(iTi,dOP,new_sl,new_tp,0,CLR_NONE);
      }
   }
 return;  
}
int OrdersManagement_Mono(double &order[][], string sSymbol="0",int iMagic=0)   
{
   if(sSymbol=="0")sSymbol=Symbol();
   int i=0, k=OrdersTotal()-1,cnt=0;
   int dg=MarketInfo(Symbol(),MODE_DIGITS);
   ArrayInitialize(order,0);
   ArrayResize(order,k+2);
   for(i=k;i>=0;i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
         if(OrderSymbol()==sSymbol || sSymbol=="")   {
            if(OrderMagicNumber()==iMagic || iMagic<0) {
               cnt++;
               order[cnt][1]=OrderTicket();
               order[cnt][2]=OrderType();
               order[cnt][3]=NormalizeDouble(OrderLots(),2);
               order[cnt][4]=NormalizeDouble(OrderOpenPrice(),dg);
               order[cnt][5]=NormalizeDouble(OrderStopLoss(),dg);
               order[cnt][6]=NormalizeDouble(OrderTakeProfit(),dg);
               order[cnt][7]=OrderProfit()+OrderCommission()+OrderSwap();
               order[cnt][8]=OrderMagicNumber();
               order[cnt][9]=OrderOpenTime();
            }  
         }
      }
   }
   order[0][0]=cnt;
   ArrayResize(order,cnt+1);
   for(i=1;i<=order[0][0];i++) {
      double tmp[1][10];
      if(order[i][9]<order[i+1][9])  {
         for(int j=1;j<10;j++)   {
            tmp[1][j]=order[i+1][j];
         }
         for(j=1;j<10;j++)   {
            order[i+1][j]=order[i][j];
         }
         for(j=1;j<10;j++)   {
            order[i][j]=tmp[1][j];
         }
      }
   }
/*   
   for(i=1;i<=order[0][0];i++) {
      Print("order["+i+"][9]="+order[i][9]);
   }
*/
 return(cnt);  
}
double NormalizeLot(double lot, string sy="0")  {
   if(sy=="0")sy=Symbol();
   double return_=-1.0;
   double min_lot=MarketInfo(sy,MODE_MINLOT);
   double max_lot=MarketInfo(sy,MODE_MAXLOT);
   
   double lot_step=MarketInfo(sy,MODE_LOTSTEP);
   double tmp=0.0;
   if(lot_step!=0) tmp=1/lot_step;
   else tmp=1/min_lot;
   
   return_=MathFloor(lot*tmp)/tmp;
   if(return_<min_lot || return_>max_lot)   {
      double middle=(min_lot+max_lot)*0.5;
      if(return_<middle)return_=min_lot;
      else return_=max_lot;
   }
 return(return_);  
}
double nd(double v,string sy="0") {
   if(sy=="0")sy=Symbol();
   int        dg=MarketInfo(sy,MODE_DIGITS);
 return(NormalizeDouble(v,dg));
}
bool OrderModify_(int ticket,double price,double sl,double tp,datetime exp,color clr)
{
   if(OrderSelect(ticket,SELECT_BY_TICKET))  {
      if(OrderCloseTime()>0)  {
         Print("OrderModify_:    #"+ticket+"  .");
         return(false);
      }
   }    
   double OOP=OrderOpenPrice();
   double OSL=OrderStopLoss();
   double OTP=OrderTakeProfit();
   string OSY=OrderSymbol();
   int OTY=OrderType();
   
   double StopLevel=0.0;
   double Point_=PointX(OSY);
   int Digits_=MarketInfo(OSY,MODE_DIGITS);
   
   
   bool modified=false;
   
   if (MathAbs(OOP-price)>Point_ || MathAbs(OSL-sl)>Point_ || MathAbs(OTP-tp)>Point_)   {
      for(int i=1;i<=NumOfTries;i++)   {
         while (!IsTradeAllowed()) Sleep(5*SEC);
         
         double Bid_=MarketInfo(OSY,MODE_BID);
         double Ask_=MarketInfo(OSY,MODE_ASK);
         
         StopLevel=MarketInfo(OSY,MODE_STOPLEVEL);
         if(Digits_==3 || Digits_==5) StopLevel/=10;
         
         if(sl!=0)   {
            double new_sl=0.0;
            if(OTY==OP_BUY)   {
               if(Bid_-sl<StopLevel*Point_)  {
                  new_sl=Bid_-(StopLevel+1)*Point_;
                  Print("OrderModify_:  \"sl\"    ! "+DoubleToStr(sl,Digits_)+"->"+DoubleToStr(new_sl,Digits_)+"");
                  sl=new_sl;
               }
            }
            if(OTY==OP_SELL)  {
               if(sl-Ask_<StopLevel*Point_)  {
                  new_sl=Ask_+(StopLevel+1)*Point_;
                  Print("OrderModify_:  \"sl\"    ! "+DoubleToStr(sl,Digits_)+"->"+DoubleToStr(new_sl,Digits_)+"");
                  sl=new_sl;
               }
            }
         }
         if(tp!=0)   {
            double new_tp=0.0;
            if(OTY==OP_BUY)   {
               if(tp-Ask_<StopLevel*Point_)  {
                  new_tp=Ask_+(StopLevel+1)*Point_;
                  Print("OrderModify_:  \"tp\"    ! "+DoubleToStr(tp,Digits_)+"->"+DoubleToStr(new_tp,Digits_)+"");
                  tp=new_tp;
               }
            }
            if(OTY==OP_SELL)  {
               if(Bid_-tp<StopLevel*Point_)  {
                  new_tp=Bid_-(StopLevel+1)*Point_;
                  Print("OrderModify_:  \"tp\"    ! "+DoubleToStr(tp,Digits_)+"->"+DoubleToStr(new_tp,Digits_)+"");
                  tp=new_tp;
               }
            }
         }
         
         modified=OrderModify(ticket,price,sl,tp,exp,clr);
         Sleep(1*SEC);
         if(modified)return(true);
         else  {
            Sleep(10*SEC);
            continue;
         } 
      }
   }
   return(modified);   
}
void OrdersClose(double &order[][],int ty=-1)   
{
   for(int i=1;i<=order[0][0];i++)  {
      int iTY=order[i][2];
      int iTI=order[i][1];
      double dLots=order[i][3];
      if(ty==-1 || iTY==ty) {
         if(iTY==OP_BUY) OrderClose_(iTI,dLots,Bid,3,Green);
         if(iTY==OP_SELL)OrderClose_(iTI,dLots,Ask,3,Orange);
      }
   }
}
datetime LastOpenTime(double order[][],int ty)
{
   datetime max_time=0;
   for(int i=1;i<=order[0][0];i++)  {
      int TY=order[i][2];
      if(TY==ty || ty==-1) {
         datetime tm=order[i][9];
         if(tm>max_time)max_time=tm;
      }
   }
 return(max_time);     
}